#!/usr/bin/env python2.5
# -*- coding: iso-8859-15 -*-
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License as 
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version
# 
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
# General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the Free Software 
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#
# Written and Copyright - Rick Cull 2009.
#
#
# echo "user ALL = NOPASSWD: /bin/cp /home/user/.advoid/orighosts /etc/hosts" 
#                                            >> /etc/sudoers 
# echo "user ALL = NOPASSWD: /bin/cp /home/user/.advoid/tmphost /etc/hosts" 
#                                            >> /etc/sudoers 
# will need to go in deb postinstall script to allow cp a file to /etc/hosts
import gtk 
import sys
import os 
import shutil 
from gtk import gdk 
import gobject 
from urllib import urlretrieve 
from subprocess import *
from stat import *
import time,datetime
import fileinput

Has_hildon=False

try:
    import hildon,osso
    Has_hildon=True
except:
    pass

class Advoid():
    
#-------------------------------------------------------------------------------

    def Update(self):
        """
            Refresh Gui 
        """
        while gtk.events_pending():
            gtk.main_iteration()
    
#-------------------------------------------------------------------------------

    def do_Lists(self,Title,File,Store,Win,View,NewList):
        """
            read files one 8K chunk at a time and display in relevant view
        """
        self.HO_Heads = [Title]
        Line = ""

        # -------------------Downloads-------------------
        if View == self.DLview:

            if File != "": self.DLFile=open(File,'r')  # need to open if new 

            Chunk = self.DLFile.readlines(8192)     # get 8k chunk
            if not Chunk:                           # if EOF
                self.DLFile.close()
                self.Mrbutton.set_sensitive(False)

        # -------------------Personal--------------------
        elif View == self.PEview:

            if File != "": self.PEFile=open(File,'r') 

            Chunk = self.PEFile.readlines(8192)       
            if not Chunk: 
                self.PEFile.close()
                self.Mabutton.set_sensitive(False)

        # -------------------Default----------------------
        elif View == self.DEview:

            if File != "": self.DEFile=open(File,'r') 

            Chunk = self.DEFile.readlines(8192)       
            if not Chunk: 
                self.DEFile.close()
                self.Mfbutton.set_sensitive(False)


        for Line in Chunk:                     # add lines in chunk to store
            if Line.startswith("#"): continue

            if ( Line.endswith("\r\n")): 
                Line=Line[:-2]
            else: 
                Line=Line[:-1]

            if not ( Line.startswith("#") or Line.rstrip() == '' ):
                Bit=Line.split()
                try:
                    piter=Store.append([Bit[1]])           
                except:
                    print repr(Bit)
                    continue
            else:
                tmp=[]
                tmp.append(Line)
                piter=Store.append(tmp)     
                      
        if NewList:              # If ne create view and add to Window
            self.HO_Tcell=self.ListStore(self.HO_Heads,View,Store,[],[])
            Win.add(View)      
            View.show()
        else:
            View.set_model(Store)
 
#-------------------------------------------------------------------------------

    def ListStore(self,Headers,view,store,Col,cell):
        """ 
            Create liststore and tableview 
        """
        view.set_model(store)
        for i in range(len(Headers)):
            Col.append(gtk.TreeViewColumn(Headers[i]))
            Col[i].set_expand(True)
            Col[i].set_clickable(True)
            view.append_column(Col[i])
            cell.append(gtk.CellRendererText())
            Col[i].pack_start(cell[i])
            Col[i].add_attribute(cell[i], 'text', i)

        view.set_headers_visible(True)
        view.set_rules_hint(True)
        return cell

#-------------------------------------------------------------------------------



    def Get_Em_and_Put_Em(self):
        """
            call do_lists for all three files
        """
        self.MessLab.set_text("")
        self.Update()
        Types=[]
        Types.append(str)
        Lists=[["Downloaded File",self.HOME+'/.advoid/downloaded',
                 self.DLstore,self.DLWindow,self.DLview],
               ["Personal Additions",self.HOME+'/.advoid/personal',
                 self.PEstore,self.PEWindow,self.PEview],
               ["Current System Settings",'/etc/hosts',
                 self.DEstore,self.DEWindow,self.DEview]]
        for f in Lists: 
            self.do_Lists(Title=f[0],
                          File=f[1],
                          Store=f[2],
                          Win=f[3],
                          View=f[4],
                          NewList=True) 

#-------------------------------------------------------------------------------

    def Another_chunk(self,Which):
        """
            read another chunk from file - callback from 'More' button
        """
        if Which == "DL":
            self.do_Lists(Title="Downloaded",
                          File='',
                          Store=self.DLstore,
                          Win=self.DLWindow,
                          View=self.DLview,
                          NewList=False)
        elif Which == "PE":
            self.do_Lists(Title="Personal Additions",
                          File='',
                          Store=self.PEstore,
                          Win=self.PEWindow,
                          View=self.PEview,
                          NewList=False)
        elif Which == "DE":
            self.do_Lists(Title="Current System Settings",
                          File='',
                          Store=self.DEstore,
                          Win=self.DEWindow,
                          View=self.DEview,
                          NewList=False)

#-------------------------------------------------------------------------------

    def DoCopy(self,FromPath,ToPath):  
        """
            use Popen to do file coies to /etc/hosts
        """
        try:
            self.P = Popen(['sudo cp ' + FromPath + ' ' + ToPath ],
                            shell=True,
                            stdin=PIPE,
                            stdout=PIPE )
            sys.stdout.flush()
            time.sleep(1)
        except Exception,e:
            self.MessLab.set_markup(self.red +\
                      "Failed to copy file to /etc/hosts </span>"+repr(e))
        else:
            self.MessLab.set_markup(self.green+"Operation successfull</span>")
       
#-------------------------------------------------------------------------------

    def Fin(self,n):
        """
            Quit program
        """
        self.DLFile.close()
        self.DEFile.close()
        self.PEFile.close()
        exit()

#-------------------------------------------------------------------------------

    def Orig_Hosts(self,n):
        """
            Copy orighists back to /etc/hosts
        """
        self.MessLab.set_text("")
        self.Update()
        self.MessLab.set_markup(self.amber+"Reverting to Default.</span>")
        self.DEstore.clear() 
        self.Update()
        self.DoCopy(self.HOME+"/.advoid/orighosts",'/etc/hosts') 

        self.do_Lists(Title="Current System Settings",      
                      File='/etc/hosts', 
                      Store=self.DEstore, 
                      Win=self.DEWindow,
                      View=self.DEview,
                      NewList=False)                # refill with /etc/hosts

#-------------------------------------------------------------------------------

    def Upd_Host_File(self,n):
        """
            Create a new Hostfile from original host, mvps and personal files 
            in ~/.advoid and copy to /etc/hosts
        """
        self.MessLab.set_text("")
        self.MessLab.set_markup(self.amber+"Updating hostfile..</span>")
        # clear existing liststore
        self.DEstore.clear() 
        self.Update()

        if not self.DEFile.closed: self.DEFile.close()
        if not self.PEFile.closed: self.DEFile.close()
        if not self.DLFile.closed: self.DEFile.close()
 
        # if there is an existing tmphost file dlete it
        if os.path.exists(self.HOME+"/.advoid/tmphost"):
            try:
                os.remove(self.HOME+"/.advoid/tmphost")
            except Exception,e:
                self.MessLAb.set_markup(self.red+\
                         "Error removing"+self.HOME+"/.advoid/tmphost</span>")
        
        # Open New tmphost for append
        tmphost = open(self.HOME+"/.advoid/tmphost",'a')
        
        #----------------- Original Defaults ----------------------

        # Open the three files to be concatenated to create new hostfile
        # Start with the original /etc/hosts contents
        self.DEFile=open(self.HOME+"/.advoid/orighosts","r")
        Lines=self.DEFile.readlines()
        for Line in Lines: tmphost.write(Line)
        self.DEFile.close()        

        #------------------ Personal Additions ---------------------
        # Concatinate personal URLs
        self.PEFile=open(self.HOME+"/.advoid/personal","r")
        Lines=self.PEFile.readlines()
        for Line in Lines: tmphost.write(Line)        
        self.PEFile.close()

        #------------------ Downloade File -------------------------
        # Cocatinate Adblock file from mvps
        self.DLFile=open(self.HOME+"/.advoid/downloaded","r")
        Lines=self.DLFile.readlines()
        for Line in Lines:   # If Dos style replace crlf with lf
            if Line.endswith("\r\n"):          # Dos style
                tmphost.write(Line[:-2]+"\n")  # Unix style
            else:
                tmphost.write(Line)
        self.DLFile.close
        
        Lines=""
        tmphost.close()
        
        self.DoCopy(self.HOME+"/.advoid/tmphost",'/etc/hosts')  
 
        self.Mfbutton.set_sensitive(True)
        self.do_Lists(Title="Current Sytem Settings",  # refill liststore with
                      File='/etc/hosts',               # contents of /etc/hosts
                      Store=self.DEstore, 
                      Win=self.DEWindow,
                      View=self.DEview,
                      NewList=False) 
 
#-------------------------------------------------------------------------------

    def Add_New_Url(self,n):
        """ 
            'Add button' callback. 
            Get contents of the entry and do some validation.
        """
        NewUrl=[]
        if self.AddEntry.get_text() == "" or self.AddEntry.get_text() is None:
            self.InfLab.set_text("You must enter a new URL here !!!")
        else:    
            try:
                File=open(self.HOME+"/.advoid/personal",'a')
                File.write("127.0.0.1 "+self.AddEntry.get_text()+"\n")
            except Exception,e:
                self.MessLAb.set_markup(self.red+\
                    "Error writing to "+self.HOME+"/.advoid/personal</span>")
            finally:
                File.close()
            NewUrl.append(self.AddEntry.get_text())
            self.PEstore.append(NewUrl)
            self.AddEntry.set_text("")
#-------------------------------------------------------------------------------

    def download(self,n):
        """" 
            'Download New' callback 
            Get a new ad server host file from www.mvps.org, save and
            update liststore and view
        """
        self.MessLab.set_text("")
        self.Update()
        self.DLstore.clear()
        if self.DLFile.open:
            self.DLFile.close()

        try:
            self.MessLab.set_markup(self.amber+\
                    "Updating Ad blocking list from 'www.mvps.org' ...</span>")
            self.Update()
            ret=urlretrieve('http://www.mvps.org/winhelp2002/hosts.txt',
                             self.HOME+"/.advoid/downloaded")
            sys.stdin.flush()
            sys.stdout.flush()
            time.sleep(1)
        except IOError :
            self.MessLab.set_markup(self.red+\
           "Unable to retrieve file. Check your internet connection !!!</span>")
            self.Update()
            ret = None
        else:
            self.MessLab.set_markup(self.green+"Update from 'www.mvps.org' Complete</span>")
            self.Update()    
        finally:
            self.Mrbutton.set_sensitive(True)
            self.do_Lists(Title="Downloaded File ",
                          File=self.HOME+'/.advoid/downloaded', 
                          Store=self.DLstore, 
                          Win=self.DLWindow,
                          View=self.DLview,
                          NewList=False) 
            self.Update()
        
#-------------------------------------------------------------------------------

    def shot(self,n,Type="F",Res="80"):
         """ 
             Screenshot utility
             Using for devel purposes remove when dun
         """
         time.sleep(5)
         t=datetime.datetime.now()
         fname="Shot"+str(int(time.mktime(t.timetuple())))+"."
         format = "jpeg"
         screenw = gtk.gdk.screen_width()
         screenh = gtk.gdk.screen_height()
         root=gtk.gdk.screen_get_default()
         if Type == "A":
             active = root.get_active_window()
             relativex, relativey, winw, winh, d = active.get_geometry() 
             screenw = winw + (relativex*2)
             screenh = winh + (relativey+relativex)
             screenposx, screenposy = active.get_root_origin()
         else :
             screenposx=0
             screenposy=0

         screenshot = gtk.gdk.Pixbuf.get_from_drawable(
                 gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB,True,8,screenw,screenh),
                 gtk.gdk.get_default_root_window(),
                 gtk.gdk.colormap_get_system(),
                 screenposx, screenposy, 0, 0, screenw, screenh)
         screenshot.save(fname + format, format,  {"quality": Res})
         print "Taken"
            #-------------------------------------------------------------------------------

    def on_window_state_change(self,widget,event,*args):
        """ 
            Set window_in_fullscreen acording to state 
         """
        if event.new_window_state & gtk.gdk.WINDOW_STATE_FULLSCREEN:
            self.window_in_fullscreen = True
        else:
            self.window_in_fullscreen = False
            #-------------------------------------------------------------------------------

    def on_key_press(self,widget,event,*args):
        """ 
            Various key bindings 
        """
        #--------------------------------------------------------------------

        def Do_Settings():
            """
                Action font changes
            """
            Settings=gtk.settings_get_for_screen(gdk.screen_get_default())
            gtk.rc_parse_string(self.Style1 + str(self.fsize) + self.Style2)
            gtk.rc_reset_styles(Settings)

        #---------------------------------------------------------------------

        if event.keyval == gtk.keysyms.F6:        # Toggle fullscreen
            if self.window_in_fullscreen:
                self.window.unfullscreen()
                self.window_in_fullscreen = False
            else:
                self.window.fullscreen()
                self.window_in_fullscreen = True    

        if event.keyval == gtk.keysyms.F7:         # Increment Font size
            if self.fsize < self.ftop: 
                self.fsize += 2 
                Do_Settings()
            else: 
                return
            
        if event.keyval == gtk.keysyms.F8:         # Decrement Font size
            if self.fsize > self.fbot: 
                self.fsize -= 2 
                Do_Settings()
            else: 
                return
   
#-------------------------------------------------------------------------------

    def Delete_Selected(self,Which):
        """
            callback for 'Delete' button
        """
        self.PEiter=self.PEstore.get_iter(self.PEpath)        
        Iter=self.PEstore.remove(self.PEiter)
        self.Update()
        for Line in fileinput.input(self.HOME+"/.advoid/personal",inplace=1):
            Line = Line.strip()
            if not self.PEdel in Line:
                print Line

#-------------------------------------------------------------------------------

    def Credits(self):
        """
            Credits dialog
        """
        self.Idialog = gtk.Dialog(title='Credits',
                    buttons=("Dismiss", gtk.RESPONSE_OK))

        self.Idialog.set_border_width(2)
        self.Idialog.set_size_request(650,350)
        lwindow = gtk.ScrolledWindow()
        lwindow.set_shadow_type(gtk.SHADOW_IN)
        self.Idialog.vbox.pack_start(lwindow,True,True,0)
        self.mvps="The Ad blocking hostfile is downloaded from http://www.mvps.org/winhelp2002/ and is Licensed under the Creative Commons  Attribution-NonCommercial-ShareAlike License."

        Gpl=\
        """
Advoid allows you to update your system with a downloaded list of advert-servers from the internet.this results in blocking adverts from any browser used with the system.

There is also the option of adding any servers not currently included in this downloaded list - see the entrybox and button at the top of the main screen. 

Use 'Update my System' after any change ( ie new download or new personnal URL added ) or Use 'Revert to Default' to return to your original settings.

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version
 
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, 
Suite 330, Boston, 
MA 02111-1307, 
USA.
     

Written and Copyright - Rick Cull 2009.
        
"""

        self.InfoLab=gtk.Label()
        self.InfoLab.set_line_wrap(True)
        self.InfoLab.set_justify(gtk.JUSTIFY_CENTER)
        self.Info_For_Lab='<i><span size="small">'+Gpl+self.mvps+"\n\n"+self.Last+"</span></i>"

        self.InfoLab.set_markup(self.Info_For_Lab)
        lwindow.add_with_viewport(self.InfoLab)
        self.Idialog.show_all()

        result = self.Idialog.run()

        if result == gtk.RESPONSE_OK:
            self.Idialog.destroy()

#-------------------------------------------------------------------------

    def __init__(self):
        """
            Main
        """
        # PC or Tablet ???
        if Has_hildon:
            self.program=hildon.Program()
            self.program.__init__()
            self.window = hildon.Window()
            self.window_in_fullscreen = True
            self.window.fullscreen()
            self.ftop=28
            self.fbot=10
            self.fsize=18    
        else:
            self.window = gtk.Window()
            self.window.set_size_request(800,480)
            self.ftop=24
            self.fbot=6
            self.fsize=10    

        self.Style1=\
        """
        style "view-font"
        {
           GtkTreeView ::expander-size = 32
           GtkTreeView ::vertical-seperator = 32
           font_name = "Sans """
        self.Style2=\
        """ "
        }
        style "e-style"
        {
           font_name = "Sans 20"
        }
        class "GtkEntry" style "e-style"
        class "GtkTreeView" style "view-font" """
        gtk.rc_parse_string(self.Style1+str(self.fsize)+self.Style2)
    
        # Some Vars
        Types=[]
        Types.append(str)
        self.ImHome='/usr/share/pixmaps/advoid'
        self.DLstore=gtk.ListStore(*Types)
        self.DLview=gtk.TreeView()
        self.PEstore=gtk.ListStore(*Types)
        self.PEview=gtk.TreeView()
        self.DEstore=gtk.ListStore(*Types)
        self.DEview=gtk.TreeView()
        self.PEpath=""
        self.DLFile=0
        self.PEFile=0
        self.DEFile=0
        self.PEiter=gtk.TreeIter
        self.HOME=os.environ.get('HOME')
        self.Ydate=""
        self.red='<span foreground="red">'
        self.amber='<span foreground="orange">'
        self.green='<span foreground="#127E15">'
        self.Vis=False
        self.Loaded=False
        self.HO_Tcell=gtk.TreeView()
        self.MyFiles=["personal","downloaded"]

        self.MessFrame=gtk.Frame()
        self.MessFrame.set_shadow_type(gtk.SHADOW_IN)
        self.MessLab=gtk.Label("")
        self.MessFrame.add(self.MessLab)
        self.window_in_fullscreen = False
         
        # check ~/.advoid folder exists
        if not os.path.exists(self.HOME+"/.advoid"):
            try:
                os.mkdir(self.HOME+"/.advoid")
            except:
                self.MessLab.set_text("Unable to create "+self.HOME+"/.advoid")

        # Check needed files present.
        for f in self.MyFiles:
            File=self.HOME+"/.advoid/"+f
            if not os.path.exists(self.HOME+"/.advoid/"+f):
                try:
                    tmp=open(File,'w')
                    tmp.close()
                except Exception,e:
                    self.MessLab.set_text("Unable to create "+f+"\n"+repr(e))
        
        # Check if orighosts in .advoids else copy /etc/hosts
        if not os.path.exists(self.HOME+"/.advoid/orighosts"):
            self.DoCopy('/etc/hosts',self.HOME+"/.advoid/orighosts")
            
        # download date
        self.Dmode=os.stat(self.HOME+"/.advoid/downloaded")[ST_MTIME]
        self.Darr=time.gmtime(self.Dmode)

        self.Last="The Ad Blocking file was last downloaded - "+\
        str(self.Darr[3])+":"+str(self.Darr[4])+"  "+str(self.Darr[2])+\
        "-"+str(self.Darr[1])+"-"+str(self.Darr[0])

        # Signals
        self.window.connect("delete_event",self.Fin) 
        self.window.connect("key-press-event",self.on_key_press)
        self.window.connect("window-state-event",self.on_window_state_change) 

        self.CurrLab=gtk.Label("Enter new URL here.")
        self.InfLab=gtk.Label("")

        # Add URL entry, Button and labels
        self.AddBox=gtk.HBox(True,0)
        self.AddTab=gtk.Table(3,3,True)
        self.AddBox.pack_start(self.AddTab,True,True,0)
        self.AddEntry=gtk.Entry()


        self.Adimage=gtk.Image()
        self.Adimage.set_from_file(self.ImHome+'/insert-link.png')
        self.AddButt=gtk.Button()
        self.ABbox=gtk.VBox(False,0)
        self.ABbox.pack_start(self.Adimage,False,False,1)
        self.AddButt.add(self.ABbox)
        self.ABbox.show()
        self.AddButt.connect("clicked",self.Add_New_Url)

        self.AddTab.attach(self.CurrLab,0,1,0,1,gtk.EXPAND,0,0,0)
        self.AddTab.attach(self.InfLab,1,3,0,1,gtk.EXPAND,0,0,0)
        self.AddTab.attach(self.AddEntry,0,2,1,3,gtk.FILL,gtk.FILL,0,2)
        self.AddTab.attach(self.AddButt,2,3,1,3,gtk.FILL,gtk.FILL,0,2)
        self.AddBox.show_all()

        # GUI
        self.WindowBox=gtk.HBox(True,0)
        self.remotebox=gtk.VBox(False,0)
        self.remoteframe=gtk.Frame()
        self.remotebox.pack_start(self.remoteframe,True,True,0)
        self.remoteframe.show()
        self.Addedbox=gtk.VBox(False,0)
        self.Addedframe=gtk.Frame()
        self.Addedbox.pack_start(self.Addedframe,True,True,0)
        self.Addedframe.show()
        self.Factorybox=gtk.VBox(False,0)
        self.Factoryframe=gtk.Frame()
        self.Factorybox.pack_start(self.Factoryframe,True,True,0)
        self.Factoryframe.show()

        self.Mrimage=gtk.Image()
        self.Mrimage.set_from_file(self.ImHome+'/gtk-refresh.png')
        self.Mrbutton=gtk.Button()
        self.Mrbox=gtk.VBox(False,0)
        self.Mrbox.pack_start(self.Mrimage,False,False,0)
        self.Mrbox.show()  
        self.Mrbutton.add(self.Mrbox)
        self.Mrbutton.show()
        self.Mrbutton.connect("clicked",lambda w: self.Another_chunk("DL"))
        self.Mrbbox=gtk.HBox(True,0)
        self.Mrbbox.pack_end(self.Mrbutton,True,True,0)
        self.Mrbbox.show()

        self.Maimage=gtk.Image()
        self.Maimage.set_from_file(self.ImHome+'/gtk-refresh.png')
        self.Mabutton=gtk.Button()
        self.Mabox=gtk.VBox(False,0)
        self.Mabox.pack_start(self.Maimage,False,False,0)
        self.Mabox.show()  
        self.Mabutton.add(self.Mabox)
        self.Mabutton.show()
        self.Mabutton.connect("clicked",lambda w: self.Another_chunk("PE"))
        self.Mabbox=gtk.HBox(True,0)
        self.Mabbox.pack_end(self.Mabutton,True,True,0)
        self.Mabbox.show()

        self.Deimage=gtk.Image()
        self.Deimage.set_from_file(self.ImHome+'/gtk-delete.png')
        self.Debutton=gtk.Button()
        self.Debox=gtk.VBox(False,0)
        self.Debox.pack_start(self.Deimage,False,False,0)
        self.Debox.show()  
        self.Debutton.add(self.Debox)
        self.Debutton.show()
        self.Debutton.connect("clicked",lambda w: self.Delete_Selected("PE"))
        self.Debbox=gtk.HBox(True,0)
        self.Mabbox.pack_end(self.Debutton,True,True,0)

        self.Mfimage=gtk.Image()
        self.Mfimage.set_from_file(self.ImHome+'/gtk-refresh.png')
        self.Mfbutton=gtk.Button()
        self.Mfbox=gtk.VBox(False,0)
        self.Mfbox.pack_start(self.Mfimage,False,False,0)
        self.Mfbox.show()  
        self.Mfbutton.add(self.Mfbox)
        self.Mfbutton.show()
        self.Mfbutton.connect("clicked",lambda w: self.Another_chunk("DE"))
        self.Mfbbox=gtk.HBox(True,0)
        self.Mfbbox.pack_end(self.Mfbutton,True,True,0)
        self.Mfbbox.show()

        self.WindowBox.pack_start(self.remotebox,True,True,0)
        self.WindowBox.pack_start(self.Addedbox,True,True,3)
        self.WindowBox.pack_start(self.Factorybox,True,True,0)

        self.DLWindow = gtk.ScrolledWindow()
        self.DLWindow.set_border_width(1)
        self.DLWindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.remoteframe.add(self.DLWindow)
        self.remotebox.pack_start(self.Mrbbox,False,False,0)
        self.remotebox.show_all()

        self.PEWindow = gtk.ScrolledWindow()
        self.PEWindow.set_border_width(1)
        self.PEWindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.Addedframe.add(self.PEWindow)
        self.Addedbox.pack_start(self.Mabbox,False,False,0)
        self.Addedbox.show_all()
        self.Addedbox.show()

        self.DEWindow = gtk.ScrolledWindow()
        self.DEWindow.set_border_width(1)
        self.DEWindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.Factoryframe.add(self.DEWindow)
        self.Factorybox.pack_start(self.Mfbbox,False,False,0)
        self.Factorybox.show_all()
        self.WindowBox.show()

        self.Deimage=gtk.Image()
        self.Deimage.set_from_file(self.ImHome+'/go-down.png')
        self.DefButtLab=gtk.Label("Default")
        self.DefButtLab.set_justify(gtk.JUSTIFY_CENTER)
        self.DefButtLab.show()
        self.DefButt=gtk.Button()
        self.Debox=gtk.VBox(False,0)
        self.Debox.pack_start(self.Deimage,False,False,0)
        self.Debox.pack_start(self.DefButtLab,False,False,0)
        self.DefButt.add(self.Debox)
        self.Debox.show()
        self.DefButt.connect("clicked",self.Orig_Hosts)

        self.Eimage=gtk.Image()
        self.Eimage.set_from_file(self.ImHome+'/gtk-quit.png')
        self.EButtLab=gtk.Label("End Program")
#        self.EButtLab.set_justify(gtk.JUSTIFY_CENTER)
        self.EButtLab.show()
        self.EButt=gtk.Button()
        self.Ebox=gtk.VBox(False,0)
        self.Ebox.pack_start(self.Eimage,False,False,0)
        self.Ebox.pack_start(self.EButtLab,False,False,0)
        self.EButt.add(self.Ebox)
        self.Ebox.show()
        self.EButt.connect("clicked",self.Fin)

        self.Doimage=gtk.Image()
        self.Doimage.set_from_file(self.ImHome+'/go-up.png')
        self.DoButtLab=gtk.Label("Update System")
        self.DoButtLab.show()
        self.DoButt=gtk.Button()
        self.Dbox=gtk.VBox(False,0)
        self.Dbox.pack_start(self.Doimage,False,False,0)
        self.Dbox.pack_start(self.DoButtLab,False,False,0)
        self.DoButt.add(self.Dbox)
        self.Dbox.show()
        self.DoButt.connect("clicked",self.Upd_Host_File)

        self.Upimage=gtk.Image()
        self.Upimage.set_from_file(self.ImHome+'/gtk-jump-to-ltr.png')
        self.UpButtLab=gtk.Label("Download")
        self.UpButtLab.show()
        self.UpButt=gtk.Button()
        self.Ubox=gtk.VBox(False,0)
        self.Ubox.pack_start(self.Upimage,False,False,0)
        self.Ubox.pack_start(self.UpButtLab,False,False,0)
        self.UpButt.add(self.Ubox)
        self.Ubox.show()
        self.UpButt.connect("clicked",self.download)

        self.tbox=gtk.VBox(False,0)
        self.bbox=gtk.HBox(True,0)
        self.bbox.pack_start(self.UpButt,True,True,0)
        self.bbox.pack_start(self.DoButt,True,True,0)
        self.bbox.pack_start(self.DefButt,True,True,0)
        self.bbox.pack_start(self.EButt,True,True,0)
        self.window.add(self.tbox)
        abox=gtk.VBox(False,0)
        wbox=gtk.VBox(True,0)
        mbox=gtk.VBox(False,0)
        bbox=gtk.VBox(True,0)
        abox.pack_start(self.AddBox,False,False,0)
        wbox.pack_start(self.WindowBox,True,True,0)
        mbox.pack_start(self.MessFrame,False,False,)
        bbox.pack_start(self.bbox,True,True,0)
        self.tbox.pack_start(abox,False,False,0)
        self.tbox.pack_start(wbox,True,True,0)
        self.tbox.pack_start(mbox,False,False,0)
        self.tbox.pack_start(bbox,False,True,0)
        self.tbox.show()
        self.window.show_all()
        mode=os.stat(self.HOME+"/.advoid/downloaded")[ST_MTIME]
        Arr=time.gmtime(mode)

        #----------------------------------------------------------
        
        def Sel(PEsel,*args): 
            """ Callback for 'Selection Changed' """
            if self.PEstore.get_iter_first() is None: return
            (model,self.PEiter) = PEsel.get_selected()
            if self.PEiter != None:
                self.PEpath=model.get_path(self.PEiter)
                self.PEdel = model.get_value(self.PEiter, 0)

        #------------------------------------------------------------
        
        PEsel=self.PEview.get_selection() 
        PEsel.set_mode(gtk.SELECTION_SINGLE) 
        PEsel.connect('changed',Sel)

        self.InfLab.set_text("Last Download - "+
            str(Arr[3])+":"+
            str(Arr[4])+"  "+
            str(Arr[2])+"/"+
            str(Arr[1])+"/"+
            str(Arr[0]))

        self.Credits()

        self.Get_Em_and_Put_Em()

    def run(self):
        gtk.main()

if __name__ == "__main__":
    try:
        osso_context = osso.Context("net.rcull.advoid","0.3",False)
    except Exception,e:
        if repr(e).find("NameError") == 0:
            pass
        else:
            print "Error when testing for osso"
    app=Advoid()
    app.run()
